extends Control

onready var edge_node = get_node("../edge_vp/scene/Camera/edge")

onready var ui_outline_mode = get_node("GridContainer/TabContainer/GridContainer/HSplitContainer/OptionButton")
onready var ui_outline_intensity = get_node("GridContainer/TabContainer/GridContainer/HSplitContainer5/HSlider1")
onready var ui_outline_bias = get_node("GridContainer/TabContainer/GridContainer/HSplitContainer3/HSlider2")
onready var ui_display_edge_only = get_node("GridContainer/TabContainer/GridContainer/HSplitContainer4/edges")
onready var ui_outline_color = get_node("GridContainer/TabContainer/GridContainer/HSplitContainer2/ColorPickerButton")

var outline_mode;
var outline_intensity;
var outline_bias;
var display_edge_only;

func _ready():
  outline_mode=edge_node.material_override.get("shader_param/outline_mode")
  outline_intensity=edge_node.material_override.get("shader_param/outline_intensity")
  outline_bias=edge_node.material_override.get("shader_param/outline_bias")
  display_edge_only=edge_node.material_override.get("shader_param/display_edge_only")
  ui_outline_color.color=edge_node.material_override.get("shader_param/outline_color")

  ui_outline_mode.select(outline_mode-1)
  ui_outline_intensity.value=outline_intensity
  ui_outline_bias.value=outline_bias
  ui_display_edge_only.pressed=bool(display_edge_only)
  pass


func _process(delta):
  pass


func _on_OptionButton_item_selected(index):
  edge_node.material_override.set("shader_param/outline_mode",index+1)


func _on_HSlider1_value_changed(value):
  edge_node.material_override.set("shader_param/outline_intensity",value)


func _on_HSlider2_value_changed(value):
  edge_node.material_override.set("shader_param/outline_bias",value)


func _on_edges_toggled(button_pressed):
  var index=get_node("GridContainer/TabContainer").current_tab
  var shader_ctr = get_node("GridContainer/TabContainer").get_child(index)
  if(index==1):
    if(get_node("GridContainer/HSplitContainer2/curv").pressed):
      edge_node.material_override.set("shader_param/display_edge_only",button_pressed)
      edge_node.material_override.set("shader_param/display_edge_local",button_pressed)
    else:
      edge_node.material_override.set("shader_param/display_edge_only",button_pressed&&(!shader_ctr.get_node("HSplitContainer4/cavity").pressed))
      edge_node.material_override.set("shader_param/display_edge_local",button_pressed&&shader_ctr.get_node("HSplitContainer4/cavity").pressed)
  else:
    edge_node.material_override.set("shader_param/display_edge_only",button_pressed)
  shader_ctr.get_node("HSplitContainer2/ColorPickerButton").disabled=button_pressed
    

func _on_cavity_toggled(button_pressed):
  edge_node.material_override.set("shader_param/display_cavity",button_pressed)
  
  var index=get_node("GridContainer/TabContainer").current_tab
  var shader_ctr = get_node("GridContainer/TabContainer").get_child(index)
  if(index==1):
    texture_rec.material.set("shader_param/use_real_cav",button_pressed)
  if(index==1)&&(!get_node("GridContainer/HSplitContainer2/curv").pressed):
    if(shader_ctr.get_node("HSplitContainer4/edges").pressed):
      edge_node.material_override.set("shader_param/display_edge_only",false||!button_pressed)
      edge_node.material_override.set("shader_param/display_edge_local",button_pressed)

func _on_sobel_thrh_value_changed(value):
  edge_node.material_override.set("shader_param/THRESHOLD",value)


func _on_ColorPickerButton_color_changed(color):
  edge_node.material_override.set("shader_param/outline_color",color)

func reset_shader_uniforms_to_ui():
  var index=get_node("GridContainer/TabContainer").current_tab
  var shader_ctr = get_node("GridContainer/TabContainer").get_child(index)
  var shader_ctr_p = get_node("GridContainer/TabContainer").get_child(int(index+1)%2)
  if(index==1):
    _on_HSlider1_value_changed(shader_ctr.get_node("HSplitContainer5/HSlider1").value)
  else:
    get_node("GridContainer/HSplitContainer2/curv").disabled=false
  _on_HSlider2_value_changed(shader_ctr.get_node("HSplitContainer3/HSlider2").value)
  _on_OptionButton_item_selected(shader_ctr.get_node("HSplitContainer/OptionButton").selected)
  _on_edges_toggled(shader_ctr.get_node("HSplitContainer4/edges").pressed)
  _on_cavity_toggled(shader_ctr.get_node("HSplitContainer4/cavity").pressed)
  if(!get_node("GridContainer/HSplitContainer2/curv").pressed):
    shader_ctr.get_node("HSplitContainer2/ColorPickerButton").color=shader_ctr_p.get_node("HSplitContainer2/ColorPickerButton").color
    _on_ColorPickerButton_color_changed(shader_ctr_p.get_node("HSplitContainer2/ColorPickerButton").color)

onready var norm_vp = get_node("../norm_vp")
var edge_mat1=load("res://edge_1.material") as Material
var edge_mat2=load("res://edge_2.material") as Material
onready var usenorm_node = get_node("GridContainer/TabContainer/GridContainer2/use_norm")
onready var tabc = get_node("GridContainer/TabContainer")
func _on_depth_norm_mode_item_selected(index):
  if(index==1):
    edge_node.material_override = edge_mat2
    _on_use_norm_toggled(usenorm_node.pressed)
    var ntx = norm_vp.get_texture()
    ntx.flags=Texture.FLAG_FILTER
    edge_node.material_override.set("shader_param/norm_texture",ntx)
  else:
    if(index==0):
      edge_node.material_override = edge_mat1
      _on_use_norm_toggled(usenorm_node.pressed)
  tabc.current_tab=index
  var shader_ctr = get_node("GridContainer/TabContainer").get_child(get_node("GridContainer/TabContainer").current_tab)
  if(get_node("GridContainer/HSplitContainer2/curv").pressed):
    _on_curv_toggled(true,true)
  else:
    var edge_ctr = shader_ctr.get_node("HSplitContainer4/edges")
    var cav_ctr = shader_ctr.get_node("HSplitContainer4/cavity")
    edge_ctr.disabled=false
    cav_ctr.disabled=false
  reset_shader_uniforms_to_ui()


onready var render_vp = get_node("../edge_vp")
func _on_fxaa_toggled(button_pressed):
  render_vp.fxaa=button_pressed
  color_vp.fxaa=button_pressed


func _on_fxaa2_toggled(button_pressed):
  render_vp.debanding=button_pressed


func _on_debanding_value_changed(value):
  render_vp.sharpen_intensity=value


var last_status = false
onready var cav_pp = get_node("GridContainer/HSplitContainer2/cav_pp")
onready var edg_pp = get_node("GridContainer/HSplitContainer2/edg_pp")
onready var texture_rec = get_node("../TextureRect")
onready var color_vp = get_node("../color_vp")
func _on_curv_toggled(button_pressed, fake=false):
  var shader_ctr = get_node("GridContainer/TabContainer").get_child(get_node("GridContainer/TabContainer").current_tab)
  var edge_ctr = shader_ctr.get_node("HSplitContainer4/edges")
  var cav_ctr = shader_ctr.get_node("HSplitContainer4/cavity")
  texture_rec.material.set("shader_param/use_curve_edges",button_pressed)
  var index=get_node("GridContainer/TabContainer").current_tab
  texture_rec.material.set("shader_param/use_real_cav",(index==1)&&(cav_ctr.pressed))
  
  if(get_node("GridContainer/TabContainer/GridContainer2/HSplitContainer4/normtxd").pressed&&button_pressed==true):
    get_node("GridContainer/TabContainer/GridContainer2/HSplitContainer4/normtxd").pressed=false
  get_node("GridContainer/TabContainer/GridContainer2/HSplitContainer4/normtxd").disabled=button_pressed
  
  if(button_pressed):
    last_status=edge_ctr.pressed
    edge_ctr.pressed=button_pressed
    if(edge_ctr.pressed==last_status):
      _on_edges_toggled(last_status)
    edge_ctr.disabled=true
    if(index==0):
      cav_ctr.disabled=true
    cav_pp.disabled=false
    edg_pp.disabled=false
    color_vp.render_target_update_mode=Viewport.UPDATE_ALWAYS
    if(!fake):
      get_node("GridContainer/PanelContainer/VBoxContainer/HSplitContainer2/color_pp").color=shader_ctr.get_node("HSplitContainer2/ColorPickerButton").color
      _on_color_pp_color_changed(shader_ctr.get_node("HSplitContainer2/ColorPickerButton").color)
  else:
    if(edge_ctr.pressed==last_status):
      _on_edges_toggled(last_status)
    edge_ctr.pressed=last_status
    edge_ctr.disabled=false
    cav_ctr.disabled=false
    cav_pp.disabled=true
    edg_pp.disabled=true
    color_vp.render_target_update_mode=Viewport.UPDATE_DISABLED
    shader_ctr.get_node("HSplitContainer2/ColorPickerButton").color=get_node("GridContainer/PanelContainer/VBoxContainer/HSplitContainer2/color_pp").color
    _on_ColorPickerButton_color_changed(shader_ctr.get_node("HSplitContainer2/ColorPickerButton").color)
  get_node("GridContainer/PanelContainer").visible=button_pressed




func _on_msaa_norm_toggled(button_pressed):
  if(button_pressed):
    norm_vp.msaa=Viewport.MSAA_8X
  else:
    norm_vp.msaa=Viewport.MSAA_DISABLED



func _on_cav_pp_toggled(button_pressed):
  texture_rec.material.set("shader_param/display_cavity",button_pressed)


func _on_edg_pp_toggled(button_pressed):
  texture_rec.material.set("shader_param/display_edge_only",button_pressed)


func _on_color_pp_color_changed(color):
  texture_rec.material.set("shader_param/outline_color",color)
  edge_node.material_override.set("shader_param/outline_color",color)
  


func _on_ns_pp_value_changed(value):
  texture_rec.material.set("shader_param/NoiseAmount",value)


func _on_er_pp_value_changed(value):
  texture_rec.material.set("shader_param/ErrorRange",value)


func _on_ep_pp_value_changed(value):
  texture_rec.material.set("shader_param/ErrorPeriod",value)

onready var msa_node = get_node("GridContainer/TabContainer/GridContainer2/msaa_norm")
func _on_use_norm_toggled(button_pressed):
  msa_node.disabled=!button_pressed
  if(button_pressed):
    norm_vp.render_target_update_mode=Viewport.UPDATE_ALWAYS
  else:
    norm_vp.render_target_update_mode=Viewport.UPDATE_DISABLED
  edge_node.material_override.set("shader_param/use_normal_texture",button_pressed)
  


func _on_cval_value_changed(value):
  edge_node.material_override.set("shader_param/cav_val",value)


func _on_cav_x_value_changed(value):
  edge_node.material_override.set("shader_param/cav_off_x",value)


func _on_cav_y_value_changed(value):
  edge_node.material_override.set("shader_param/cav_off_y",value)


func _on_normtxd_toggled(button_pressed):
  edge_node.material_override.set("shader_param/display_normal",button_pressed)
  get_node("GridContainer/HSplitContainer2/curv").disabled=button_pressed
  


func _on_cav_st_toggled(button_pressed):
  edge_node.material_override.set("shader_param/cav_edges_st",button_pressed)
